import ox.gavin.profiling.MemoryProfiler

/** A simple example using the InstrumentationAgent memory profiler. */
class ScalaInstrumentation{
  /** The size of obj.  Note: this does not recursively follow references. */
  def getSize(obj: Object) = 
    MemoryProfiler.getSize(obj) // InstrumentationAgent.getObjectSize(obj)

  private class C(n: Int){
    val three = 3
    val children = Array.fill(n)(new C(n-1))
  }


  def apply() = {
    println(getSize("Hello world!")) // should give 24

    println(MemoryProfiler.traverse("C", new C(3), maxPrint = 6))

    // Add more calls to getSize, to profile relevant objects. 
  }
}

/* See instructions in Instrumentation.java for usage. */
 
